> ## Documentation Index
> Fetch the complete documentation index at: https://developer.rocket.chat/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Livechat Message History

> Get the entire message history of a conversation.

## OpenAPI

````json GET /api/v1/livechat/messages.history/{rid}
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0.0",
    "title": "Omnichannel"
  },
  "servers": [
    {
      "url": "https://apiexplorer.support.rocket.chat"
    }
  ],
  "tags": [
    {
      "name": "Omnichannel Users"
    },
    {
      "name": "Omnichannel Agents"
    },
    {
      "name": "Omnichannel Monitors"
    },
    {
      "name": "Omnichannel Visitors"
    },
    {
      "name": "Omnichannel Contacts"
    },
    {
      "name": "Omnichannel Rooms"
    },
    {
      "name": "Omnichannel Departments"
    },
    {
      "name": "Omnichannel Custom Fields"
    },
    {
      "name": "Omnichannel Business Hours"
    },
    {
      "name": "Omnichannel Priorities"
    },
    {
      "name": "Omnichannel Tags"
    },
    {
      "name": "Omnichannel Units"
    },
    {
      "name": "SLA Policies"
    },
    {
      "name": "Canned Responses"
    },
    {
      "name": "Omnichannel Transcript"
    },
    {
      "name": "Omnichannel Statistics"
    },
    {
      "name": "Omnichannel Agent Stats"
    },
    {
      "name": "Omnichannel Dashboards"
    },
    {
      "name": "Reports"
    },
    {
      "name": "Omnichannel Inquiries"
    },
    {
      "name": "Omnichannel Webhooks"
    },
    {
      "name": "Livechat"
    },
    {
      "name": "Livechat Appearance"
    },
    {
      "name": "Livechat Triggers"
    },
    {
      "name": "Livechat Messages"
    },
    {
      "name": "Livechat Page Visited"
    }
  ],
  "paths": {
    "/api/v1/livechat/messages.history/{rid}": {
      "parameters": [
        {
          "schema": {
            "type": "string"
          },
          "name": "rid",
          "in": "path",
          "required": "true",
          "description": "The room ID."
        }
      ],
      "get": {
        "summary": "Get Livechat Message History",
        "operationId": "get-api-v1-livechat-messages.history-rid",
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "messages": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "_id": {
                            "type": "string"
                          },
                          "rid": {
                            "type": "string"
                          },
                          "msg": {
                            "type": "string"
                          },
                          "token": {
                            "type": "string"
                          },
                          "alias": {
                            "type": "string"
                          },
                          "ls": {
                            "type": "string"
                          },
                          "u": {
                            "type": "object",
                            "properties": {
                              "_id": {
                                "type": "string"
                              },
                              "username": {
                                "type": "string"
                              },
                              "name": {
                                "type": "string"
                              }
                            }
                          },
                          "mentions": {
                            "type": "array",
                            "items": {
                              "type": "object",
                              "properties": {}
                            }
                          },
                          "channels": {
                            "type": "array",
                            "items": {
                              "type": "object",
                              "properties": {}
                            }
                          },
                          "_updatedAt": {
                            "type": "string"
                          },
                          "editedAt": {
                            "type": "string"
                          },
                          "editedBy": {
                            "type": "object",
                            "properties": {
                              "_id": {
                                "type": "string"
                              },
                              "username": {
                                "type": "string"
                              }
                            }
                          },
                          "urls": {
                            "type": "array",
                            "items": {
                              "type": "object",
                              "properties": {}
                            }
                          }
                        }
                      }
                    },
                    "unreadNotLoaded": {
                      "type": "integer"
                    },
                    "success": {
                      "type": "boolean"
                    }
                  }
                },
                "examples": {
                  "Success Example": {
                    "value": {
                      "messages": [
                        {
                          "_id": "ZKWP8LfGnRHQ3ozWa",
                          "rid": "KuACMJ5MpN6SfAFWg",
                          "msg": "editing livechat message..",
                          "token": "iNKE8a6k6cjbqWhWd",
                          "alias": "Livechat Visitor",
                          "ls": "2018-09-14T13:31:33.201Z",
                          "u": {
                            "_id": "YgEoq2djbGdjjZnsL",
                            "username": "guest-4",
                            "name": "Livechat Visitor"
                          },
                          "mentions": [],
                          "channels": [],
                          "_updatedAt": "2018-09-14T13:31:33.222Z",
                          "editedAt": "2018-09-14T13:31:33.219Z",
                          "editedBy": {
                            "_id": "YgEoq2djbGdjjZnsL",
                            "username": "guest-4"
                          },
                          "urls": []
                        }
                      ],
                      "unreadNotLoaded": "0",
                      "success": "true"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "success": {
                      "type": "boolean"
                    },
                    "error": {
                      "type": "string"
                    },
                    "errorType": {
                      "type": "string"
                    }
                  }
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "success": "false",
                      "error": "must have required property 'token' [invalid-params]",
                      "errorType": "invalid-params"
                    }
                  }
                }
              }
            }
          }
        },
        "description": "Get the entire message history of a conversation.",
        "tags": [
          "Livechat Messages"
        ],
        "parameters": [
          {
            "schema": {
              "type": "string"
            },
            "example": "iNKE8a6k6cjbqWhWd",
            "in": "query",
            "name": "token",
            "description": "The visitor token.",
            "required": "true"
          },
          {
            "schema": {
              "format": "date-time"
            },
            "example": "2018-09-14T13:31:33.201Z",
            "in": "query",
            "name": "ls",
            "description": "The timestamp to start loading the messages."
          },
          {
            "schema": {
              "format": "date-time"
            },
            "example": "2018-09-14T14:31:33.201Z",
            "in": "query",
            "name": "end"
          },
          {
            "schema": {
              "type": "number"
            },
            "example": "25",
            "in": "query",
            "name": "limit",
            "description": "The number of messages to load."
          }
        ]
      }
    }
  }
}
````

